Package com.io7m.cedarbridge.schema.compiled.internal

# Class CBProtocolDeclaration

java.lang.Object
com.io7m.cedarbridge.schema.compiled.internal.CBProtocolDeclaration

All Implemented Interfaces:
  `CBProtocolDeclarationType`

public final class CBProtocolDeclaration extends Object implements CBProtocolDeclarationType
A protocol declaration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addVersion(CBProtocolVersionDeclaration version)`
  Add a protocol version.
  `List<String>`
  `documentation()`
  `String`
  `name()`
  `CBPackageType`
  `owner()`
  `void`
  `setDocumentation(List<String> text)`
  Set the documentation.
  `void`
  `setOwner(CBPackage newOwner)`
  Set the owner of the protocol.
  `Map<BigInteger,CBProtocolVersionDeclarationType>`
  `versions()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.io7m.cedarbridge.schema.compiled.CBProtocolDeclarationType

  `id, protocolVersionsForType`

- ## Method Details

  - ### owner

    public CBPackageType owner()
    Specified by:
      `owner` in interface `CBProtocolDeclarationType`
    Returns:
      The package that owns this declaration

  - ### name

    public String name()
    Specified by:
      `name` in interface `CBProtocolDeclarationType`
    Returns:
      The package-unique declaration name

  - ### versions

    public Map<BigInteger,CBProtocolVersionDeclarationType> versions()
    Specified by:
      `versions` in interface `CBProtocolDeclarationType`
    Returns:
      The protocols by version

  - ### documentation

    public List<String> documentation()
    Specified by:
      `documentation` in interface `CBProtocolDeclarationType`
    Returns:
      Documentation for the protocol declaration

  - ### setOwner

    public void setOwner(CBPackage newOwner)
    Set the owner of the protocol.
    Parameters:
      `newOwner` - The owner package

  - ### addVersion

    public void addVersion(CBProtocolVersionDeclaration version)
    Add a protocol version.
    Parameters:
      `version` - The version

  - ### setDocumentation

    public void setDocumentation(List<String> text)
    Set the documentation.
    Parameters:
      `text` - The text